## Advanced features

Here is a list of advanced features currently supported.

+ Score function gradient
+ Reparameterization gradient
+ Variance reduction techniques
    + Analytic KL's and entropy decompositions
+ Variational models
    + Mean-field
    + Global parameterizations (inference networks, recognition networks, inverse mappings)

## References

References for the process

+ Box, G. E. P. (1976). Science and Statistics. Journal of the American Statistical Association, 71(356), 791–799. [[link](http://doi.org/10.1080/01621459.1976.10480949)]
+ Blei, D. M. (2014). Build, compute, critique, repeat: Data analysis with latent variable models. Annual Review of Statistics and Its Application. [[link](http://www.annualreviews.org/doi/pdf/10.1146/annurev-statistics-022513-115657)]
+ Gelman, A., & Shalizi, C. R. (2012). Philosophy and the practice of Bayesian statistics. British Journal of Mathematical and Statistical Psychology, 66(1), 8–38. [[link](http://arxiv.org/abs/1006.3868)]

References for modeling languages

+ Carpenter, B., Gelman A., Hoffman, M., Lee, D., Goodrich, B., Betancourt, M., Brubaker, M. A., Guo, J., Li, P., & Riddell, A. (2016). Stan: A probabilistic programming language. Journal of Statistical Software. [[link](http://www.stat.columbia.edu/~gelman/research/unpublished/stan-resubmit-JSS1293.pdf)]
+ Abadi, M., Agarwal, A., Barham, P., Brevdo, E., & Chen, Z. (2015). TensorFlow: Large-scale machine learning on heterogeneous systems. Technical Report. [[link](http://download.tensorflow.org/paper/whitepaper2015.pdf)]
+ van der Walt, S., Colbert, S. C., & Varoquaux, G. (2011). The NumPy Array: A Structure for Efficient Numerical Computation, Computing in Science & Engineering, 13, 22-30. [[link](http://scitation.aip.org/content/aip/journal/cise/13/2/10.1109/MCSE.2011.37)]

References for inference

+ Hoffman, M. D., Blei, D. M., Wang, C., & Paisley, J. (2013). Stochastic Variational Inference. Journal of Machine Learning Research, 14, 1303–1347. [[link](http://jmlr.org/papers/volume14/hoffman13a/hoffman13a.pdf)]
+ Kingma, D. P., & Welling, M. (2014). Auto-Encoding Variational Bayes. In International Conference on Learning Representations. [[link](http://arxiv.org/abs/1312.6114)]
+ Kucukelbir, A., Tran, D., Ranganath, R., Gelman, A., & Blei, D. M. (2016). Automatic Differentiation Variational Inference. arXiv preprint arXiv:1603.00788. [[link](http://arxiv.org/abs/1603.00788)]
+ Kurihara, K., Welling, M., & Vlassis, N. (2006). Accelerated Variational Dirichlet Process Mixtures. In Neural Information Processing Systems. [[link](http://papers.nips.cc/paper/3025-accelerated-variational-dirichlet-process-mixtures.pdf)]
+ Mandt, S., Mcinerney, J., Abrol, F., Ranganath, R., & Blei, D. M. (2014). Multicanonical Stochastic Variational Inference. In Artificial Intelligence and Statistics. [[link](http://arxiv.org/abs/1411.1810)]
+ Mcinerney, J., Ranganath, R., & Blei, D. M. (2015). The Population Posterior and Bayesian Inference on Streams. In Neural Information Processing Systems. [[link](http://papers.nips.cc/paper/5793-the-population-posterior-and-bayesian-modeling-on-streams.pdf)]
+ Ranganath, R., Gerrish, S., & Blei, D. M. (2014). Black Box Variational Inference. In Artificial Intelligence and Statistics. [[link](http://jmlr.org/proceedings/papers/v33/ranganath14.pdf)]
+ Ranganath, R., Tran, D., & Blei, D. M. (2015). Hierarchical Variational Models. arXiv preprint arXiv:1511.02386. [[link](http://arxiv.org/abs/1511.02386)]
+ Rezende, D. J., & Mohamed, S. (2015). Variational Inference with Normalizing Flows. In International Conference on Machine Learning. [[link](http://jmlr.org/proceedings/papers/v37/rezende15.pdf)]
+ Rezende, D. J., Mohamed, S., & Wierstra, D. (2014). Stochastic Backpropagation and Approximate Inference in Deep Generative Models. In International Conference on Machine Learning. [[link](http://jmlr.org/proceedings/papers/v32/rezende14.pdf)]
+ Salimans, T., Kingma, D. P., & Welling, M. (2015). Markov Chain Monte Carlo and Variational Inference: Bridging the Gap. In International Conference on Machine Learning. [[link](http://jmlr.org/proceedings/papers/v37/salimans15.pdf)]
+ Tran, D., Ranganath, R., & Blei, D. M. (2016). Variational Gaussian Process. In International Conference on Learning Representations. [[link](http://arxiv.org/abs/1511.06499)]

References for criticism

+ Box, G. E. P. (1980). Sampling and Bayes' inference in scientific modelling and robustness. Journal of the Royal Statistical Society. Series a. General, 143(4), 383–430.
+ Gelman, A., Meng, X.-L., & Stern, H. (1996). Posterior predictive assessment of model fitness via realized discrepancies. Statistica Sinica.
