# Feature Wishlist

__Modeling__

* A graphical modeling language

__Inference__

* Variational inference
    * Coordinate ascent variational inference
    * Expectation propagation
    * Generative adversarial networks
* Bayesian risk minimization
* Monte Carlo
    * Markov chain Monte Carlo
    * Importance sampling
    * Sequential Monte Carlo

__Criticism__

* Graphical checks
* Sensitivity analysis
* Convergence diagnostics

__Miscellaneous__

* Visualization tools
* A model zoo

## Advanced features

* Variance reduction techniques
    * Control variates
    * Markov blankets
    * Local expectation gradients
* Multicanonical variational inference
* Variational models
    * Hierarchical variational models
    * Mixture of mean-field
    * Structured factorizations
    * Normalizing flows
    * Variational Gaussian process
    * Markov chains
* Population variational inference
* Accelerated variational inference
